using System;
using System.Web;
using System.Web.UI;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Collections.Specialized;

namespace ApplicationMap
{
	public partial class Config : System.Web.UI.Page
	{
		protected override void OnLoad (EventArgs e)
		{
			XmlTextWriter writer = new XmlTextWriter(Response.OutputStream, System.Text.Encoding.UTF8); 
			
			//XmlWriterSettings settings = new XmlWriterSettings();
			//settings.Indent = true;
			//settings.OmitXmlDeclaration = false; // creates the main xml declaration
			//XmlWriter writer = XmlWriter.Create("xml/config.xml", settings);
			
			try
			{
				writer.WriteStartElement("configuration");
				writer.WriteStartElement("iomPaths");
				NameValueCollection section = (NameValueCollection)ConfigurationManager.GetSection("IomDirectories");
				
				foreach(var key in section.AllKeys) {
					writer.WriteStartElement("path");
					writer.WriteAttributeString("id", key);
					writer.WriteString(section[key]);
					writer.WriteEndElement();
				}
				writer.WriteEndElement();
				writer.WriteEndElement();
				
			  writer.Flush();
			  writer.Close();
			}
			catch (ArgumentException ex)
			{
			  Console.WriteLine("{Error: 0} = {1}", ex.ParamName, ex.Message);
			}
			finally
			{
			  if (writer != null)
			    writer.Close();
			}			
		}
	}
}

