using System;
using System.IO;
using System.Web;
using System.Web.UI;
using System.Xml;
using System.Text;
using System.Configuration;
using System.Collections.Specialized;

namespace ApplicationMap
{
	public partial class GetIOMs : System.Web.UI.Page
	{
		protected override void OnLoad (EventArgs e)
		{
			var configDirId = Request.QueryString["configDirId"];
			NameValueCollection section = (NameValueCollection)ConfigurationManager.GetSection("IomDirectories");
			XmlTextWriter writer = new XmlTextWriter(Response.OutputStream, System.Text.Encoding.UTF8);
					
			try {
				writer.WriteStartElement("ioms");
				
				if(!String.IsNullOrEmpty(configDirId))
				{
					var configDir = section[configDirId];
					if(configDir != null)
					{
						string[] filePaths = Directory.GetFiles(@configDir, "*.xml", SearchOption.AllDirectories);
						
						foreach(var filePath in filePaths) {
							writer.WriteStartElement("iom");
							
							XmlDocument xDoc = new XmlDocument();
							xDoc.Load(filePath);							
							xDoc.RemoveChild(xDoc.FirstChild);
							xDoc.WriteContentTo(writer);							
							writer.WriteEndElement();						
						}					
					}
				}
				
				writer.WriteEndElement();	
				writer.Flush();
				writer.Close();
			}
			catch (ArgumentException ex)
			{
			  Console.WriteLine("{Error: 0} = {1}", ex.ParamName, ex.Message);
			}
			finally
			{
			  if (writer != null)
			    writer.Close();
			}
		}
	}
}

