$(function () {
	var map = new APPLICATIONSMAP.Class.ApplicationsMap();
	map.Init();
	window.map = map;
	
	$("#loginButton").click(function(e){
		e.preventDefault();
		$("#form1").submit()
	});
});

(function () {
	window.APPLICATIONSMAP = {};

	var APPLICATIONSMAP = window.APPLICATIONSMAP;

	APPLICATIONSMAP.Class = {};
	APPLICATIONSMAP.Util = {};

	APPLICATIONSMAP.Util.createObject = function(objectType) {
		var F = function (objectType) { this.objectType = objectType; };
		return new F(objectType);
	};

	APPLICATIONSMAP.Class.Application = function () {
		var thisApplication = APPLICATIONSMAP.Util.createObject("Application");

		thisApplication.id = "";
		thisApplication.name = "";
		thisApplication.type = "";
		thisApplication.shortDescription = "";
		thisApplication.description = "";
		thisApplication.onMap = false;
		thisApplication.productionServers = [];
		thisApplication.databases = [];
		thisApplication.webservices = [];
		thisApplication.queues = [];
		thisApplication.shown = false;

		return thisApplication;
	};

	APPLICATIONSMAP.Class.Server = function (name) {
		var thisServer = APPLICATIONSMAP.Util.createObject("Server");

		thisServer.name = name;

		return thisServer;
	};
	
	APPLICATIONSMAP.Class.WebService = function () {
		var thisWebService = APPLICATIONSMAP.Util.createObject("WebService");

		thisWebService.id = '';
		thisWebService.name = '';
		thisWebService.description = '';

		return thisWebService;
	};
	
	APPLICATIONSMAP.Class.Queue = function () {
		var thisQueue = APPLICATIONSMAP.Util.createObject("Queue");
		thisQueue.id = '';
		thisQueue.name = '';
		return thisQueue;
	};

	APPLICATIONSMAP.Class.Database = function () {
		var thisDatabase = APPLICATIONSMAP.Util.createObject("Database");

		thisDatabase.id = "";
		thisDatabase.name = "";
		thisDatabase.description = "";
		thisDatabase.read = "";
		thisDatabase.write = "";
		thisDatabase.owner = "";
		thisDatabase.shown = false;

		return thisDatabase;
	};
	
	APPLICATIONSMAP.Class.ApplicationsMap = function () {
		var thisApplicationsMap = APPLICATIONSMAP.Util.createObject("ApplicationsMap");

		// Public properties		
		thisApplicationsMap.map = Raphael("applications-map", 700, 700);
		thisApplicationsMap.relations = [];
		thisApplicationsMap.xml = null;

		// Public methods

		// Initialization
		thisApplicationsMap.Init  = function() {
			// Load configuration directories selector
			$.get('ajax/Config.aspx', { dataType: 'xml' },
				function(xml) {
					$("<option></option>")
						.attr('value', '').html('Seleccione un directorio')
						.appendTo($('#configDirs'));
					$(xml).find('iomPaths path').each(function(){
						$("<option></option>")
						.attr('value', $(this).attr('id')).html($(this).text())
						.appendTo($('#configDirs'));
					});
					
					var configDirId = $.cookie('configDirId');
					if(configDirId != null) {
						$('#configDirs option[value="' + configDirId + '"]').attr('selected','selected');
					}
					
					thisApplicationsMap.addEvents();
				});
		};
				
		thisApplicationsMap.addEvents = function () {
			$('#load-configuration').click(thisApplicationsMap.loadConfiguration);
			$('#validate-all').click(function(e){
				e.preventDefault();
				thisApplicationsMap.validateIOMs();
			});
			$('#load-configuration').click();
			$('#applications-list-search-text').keypress(function(e){if(e.which == 13){e.preventDefault();thisApplicationsMap.Search();}});
			$('#applications-list-search-apply').click(thisApplicationsMap.Search);
			$('#applications-list-filter-show-all').click(function(e){e.preventDefault(); thisApplicationsMap.showAllApps();});
			$('#applications-list-show-filter').click(function(e){$('#filter').toggle();});
			$('#filter input[type="checkbox"]').click(thisApplicationsMap.filterApps);
		};
		
		thisApplicationsMap.filterApps = function(e) {
			thisApplicationsMap.Search();
		};
		
		thisApplicationsMap.showAllApps = function() {
			$('#filter input[type="checkbox"]').attr('checked',false);
			$("#applications-list a").show();
		};
		
		thisApplicationsMap.Search = function () {
			var searched = $('#applications-list-search-text').val(),
				filters = $('#filter input[type="checkbox"]');
			$("#applications-list a").show();
			
			if(searched != '') {
				for(id in applications) {
					var application = applications[id];
					if(stripos(application.name, searched) !== false) {
						$("a[data-id='" + id + "']").show();
					}
					else
						$("a[data-id='" + id + "']").hide();
				}
			}
			
			filters.each(function(){
				if($(this).is(":checked")) {
					var type = $(this).val();
					switch(type) {
						case 'uses-databases':
							$("a[data-uses-databases='false']").hide();
							break;
						case 'uses-queues':
							$("a[data-uses-queues='false']").hide();
							break;
						case 'uses-webservices':
							$("a[data-uses-webservices='false']").hide();
							break;
					}
				}
			});
		};
		
		thisApplicationsMap.loadConfiguration = function (e) {
			e.preventDefault();
			var option = $('#configDirs').val();
			if(option != '') {
				$.get('ajax/GetIOMs.aspx?configDirId=' + option, { dataType: 'xml' },
				function(xml) {
					$(xml).find('iom').each(function(){
						var x = $(this);
						thisApplicationsMap.processIOM($(this));
					});
					//thisApplicationsMap.sortUnorderedList('applications-list');
				});
				$.cookie('configDirId', option);
			}
		};
		
		thisApplicationsMap.validateIOMs = function() {
			var option = $('#configDirs').val();
			if(option != '') {
				$.get('ajax/ValidateIOMs.aspx?configDirId=' + option, { dataType: 'xml' },
				function(xml) {
					thisApplicationsMap.infoWindowClear();
					
					$(xml).find('iom').each(function(){
						var text = '';
						text += "IOM: " + $(this).attr("path") + ": ";
						text += ($(this).attr("validated") == "true" ? "<span class='ok'>OK</span>" : "<span class='ko'>" + $(this).attr("validated") + "</span>");
						text += "<br />";
						thisApplicationsMap.infoWindowAddInfo(text);
					});
				});
			}
		};

		thisApplicationsMap.processIOM = function (xml) {
			var componentNode = $(xml).find('component'),
				appId = $(componentNode).attr('id'),
				type = $(componentNode).attr('type'),
				shortDescription = $(componentNode).attr('shortDescription'),
				description = $(xml).find('description').text();

			
			// Add app to applications list
			var application = new APPLICATIONSMAP.Class.Application();
			application.id = appId;
			application.name = appId;
			application.type = type;
			application.shortDescription = shortDescription;
			application.description = description;

			$(xml).find('productionServers > server').each(function(){
				application.productionServers.push(new APPLICATIONSMAP.Class.Server($(this).attr('name')));
			});

			$(xml).find('databases > database').each(function(){
				application.databases.push($(this).attr('id'));
				if(databases[$(this).attr('id')] === undefined) {
					var database = new APPLICATIONSMAP.Class.Database();
					database.id = $(this).attr('id');
					database.name = $(this).attr('id');
					database.read = $(this).attr('read');
					database.write = $(this).attr('write');
					database.owner = $(this).attr('owner');
					database.description = $(this).attr('description');				
					databases[database.id] = database;
					
				}
			});
			
			$(xml).find('webServices > webService').each(function(){
				application.webservices.push($(this).attr('id'));
				if(webservices[$(this).attr('id')] === undefined) {
					var webservice = new APPLICATIONSMAP.Class.WebService();
					webservice.id = $(this).attr('id');
					webservice.name = $(this).attr('id');
					webservice.description = $(this).attr('description');				
					webservices[webservice.id] = webservice;
					
				}
			});
			
			$(xml).find('queues > queue').each(function(){
				application.queues.push($(this).attr('id'));
				if(queues[$(this).attr('id')] === undefined) {
					var queue = new APPLICATIONSMAP.Class.Queue();
					queue.id = $(this).attr('id');
					queue.name = $(this).attr('id');
					queue.description = $(this).attr('description');				
					queues[queue.id] = queue;
					
				}
			});
			
			thisApplicationsMap.addApplication(application);
		};

		// Load vertical application list
		thisApplicationsMap.addApplication = function (application) {
			// Add app to application list
			var li = $('<li></li>');
			$(li).addClass("ws");
			$('<a></a>')
				.html(application.name)
				.attr('data-id', application.id)
				.attr('data-uses-databases', application.databases.length > 0)
				.attr('data-uses-webservices', application.webservices.length > 0)
				.attr('data-uses-queues', application.queues.length > 0)
				.css('cursor', 'pointer')
				.bind('click', thisApplicationsMap.applicationClick)
				.appendTo(li);
			$(li).appendTo('#applications-list');			

			applications[application.id] = application;			
		};

		thisApplicationsMap.initMap = function (xml) {
			var relations = [],
				elems = new Object();

			$(xml).find('application').each(function(){
				applications[$(this).attr('id')] = $(this).find('name').text();
			});

			$(xml).find('application').each(function(){
				var elem = applications[$(this).attr('id')];
				$(this).find('relation').each(function(){
					relations.push([elem, applications[$(this).text()]]);
				});
			});
			
			//thisApplicationsMap.DrawMap([ 4, 1, 2, 3]);
		};
				
		thisApplicationsMap.infoWindowAddApplication = function(app) {
			var infoWindow = $("#infoWindow"),
				text = '',
				color = Raphael.getRGB("#" + (Math.abs(app.name.hashCode()) % parseInt("FFFFFF",16)).toString(16)).hex;
				
			text += "<div style='color:" + color + "'>";
			text += "<h2><strong>" + app.name + "</strong> (" + app.shortDescription + ")</h2>";
			text += "<p>Type: <strong>" + app.type + "</strong></p>";
			text += "<p>Description: <strong>" + app.description + "</strong></p>";
			
			if(app.databases.length > 0)
				text += "Databases: <strong>" + implode(", ", app.databases) + "</strong>";
			
			text += "<hr />";
			text += "</div>";
			
			infoWindow.html(infoWindow.html() + nl2br(text));
		};
		
		thisApplicationsMap.infoWindowAddInfo = function(info) {
			var infoWindow = $("#infoWindow");
			infoWindow.html(infoWindow.html() + info);
		};
		
		thisApplicationsMap.infoWindowClear = function() {
			$("#infoWindow").html('');
		};
		
		thisApplicationsMap.DrawMap = function(ids) {
			if(applications === null || applications.length == 0)
				return;

			thisApplicationsMap.resetPosition();
			thisApplicationsMap.map.clear();
			shapes = [];
			thisApplicationsMap.infoWindowClear();

			for(var i = 0, ii = ids.length, id = ids[i]; i < ii; i++) {
				var id = ids[i],
					application = applications[id];
					
				thisApplicationsMap.infoWindowAddApplication(application);
				
				thisApplicationsMap.ApplicationIcon(application.id, application.name, application.type, application.shortDescription);
				application.shown = true;

				for(var di = 0, dii = application.databases.length; di < dii; di++) {
					thisApplicationsMap.DatabaseIcon(databases[application.databases[di]]);
					application.databases[di].shown = true;
					thisApplicationsMap.addConnection(application, databases[application.databases[di]]);
				}
				
				for(var di = 0, dii = application.webservices.length; di < dii; di++) {
					thisApplicationsMap.WebServiceIcon(webservices[application.webservices[di]]);
					application.webservices[di].shown = true;
					thisApplicationsMap.addConnection(application, webservices[application.webservices[di]]);
				}
				
				for(var di = 0, dii = application.queues.length; di < dii; di++) {
					thisApplicationsMap.QueueIcon(queues[application.queues[di]]);
					application.queues[di].shown = true;
					thisApplicationsMap.addConnection(application, queues[application.queues[di]]);
				}
			}
		};

		thisApplicationsMap.applicationClick = function (e) {
			e.preventDefault();

			// If no multiple selection, remove selected css class
			// and clear array of shown applications
			if(!e.ctrlKey) {
				$('.selected').removeClass('selected');
				shownAplications.clear();
			}
			
			$(this).addClass('selected');
			shownAplications.push($(this).attr('data-id'));
			thisApplicationsMap.DrawMap(shownAplications);
		};
		
		thisApplicationsMap.tooltipTemplate = '<div></div>';
		
		thisApplicationsMap.ApplicationIcon = function(id, name, type, description) {
			var position = thisApplicationsMap.nextPosition(),
				elem = thisApplicationsMap.map.rect(position.x, position.y, 60, 40),
				color = Raphael.getRGB("#" + (Math.abs(name.hashCode()) % parseInt("FFFFFF",16)).toString(16)).hex,
				text = name.concat("\n", type, "\n", description);

			elem.attr({fill: color, stroke: color, cursor: "move"})
				.drag(move, dragger, up)
				.hover(function(e){thisApplicationsMap.setTooltip(name, e.x, e.y);},function(){$(tip).hide();});
			console.log($(elem));
			shapes[id] = elem;
			return elem;
		};
		
		thisApplicationsMap.setTooltip = function(name, x, y) {
			$(tip).css("left", x + 5 + "px").css("top", y);
			$(tip).html(name);
			$(tip).show();
		};

		thisApplicationsMap.DatabaseIcon = function(database) {
			var elem = shapes[database.id];
			
			if(elem == null || elem == undefined) {
				var position = thisApplicationsMap.nextPosition(),
					color = Raphael.getRGB("#" + (Math.abs(database.name.hashCode()) % parseInt("FFFFFF",16)).toString(16)).hex,
					text = database.id;
					console.log(color);

				elem = thisApplicationsMap.map.image('img/database.png', position.x, position.y, 48, 48);
				elem.attr({fill: "#fff", stroke: color, title: name, text: text, cursor: "move"})
					.drag(move, dragger, up)
					.hover(function(e){thisApplicationsMap.setTooltip("<strong>Database: </strong>" + database.name, e.x, e.y);},function(){$(tip).hide();});
				
				shapes[database.id] = elem;
			}
			return elem;
		};
		
		thisApplicationsMap.WebServiceIcon = function(webservice) {
			var elem = shapes[webservice.id];
			
			if(elem == null || elem == undefined) {
				var position = thisApplicationsMap.nextPosition(),
					color = Raphael.getRGB("#" + (Math.abs(webservice.name.hashCode()) % parseInt("FFFFFF",16)).toString(16)).hex,
					text = webservice.id;
					console.log(color);

				//elem = thisApplicationsMap.map.ellipse(position.x, position.y, 20, 20)
				elem = thisApplicationsMap.map.image('img/webservice.png', position.x, position.y, 48, 48);
				elem.attr({fill: "#fff", stroke: color, title: name, text: text, cursor: "move"})
					.drag(move, dragger, up)
					.hover(function(e){thisApplicationsMap.setTooltip("<strong>WebService: </strong>" + webservice.name, e.x, e.y);},function(){$(tip).hide();});
				
				shapes[webservice.id] = elem;
			}
			return elem;
		};
		
		thisApplicationsMap.QueueIcon = function(queue) {
			var elem = shapes[queue.id];
			
			if(elem == null || elem == undefined) {
				var position = thisApplicationsMap.nextPosition(),
					color = Raphael.getRGB("#" + (Math.abs(queue.name.hashCode()) % parseInt("FFFFFF",16)).toString(16)).hex,
					text = queue.id;
					console.log(color);

				elem = thisApplicationsMap.map.image('img/queue.png', position.x, position.y, 48, 48);
				elem.attr({fill: "#fff", stroke: color, title: name, text: text, cursor: "move"})
					.drag(move, dragger, up)
					.hover(function(e){thisApplicationsMap.setTooltip("<strong>Queue: </strong>" + queue.name, e.x, e.y);},function(){$(tip).hide();});
				
				shapes[queue.id] = elem;
			}
			return elem;
		};

		// Private methods and properties
		var connections = [],
		shownAplications = [],
		applications = new Object(),
		databases = new Object(),
		queues = new Object(),
		webservices = new Object(),
		shapes = new Object(),
		dragger = function () {
			console.log(this.attrs.x);
			this.ox = this.type == "rect" ? this.attr("x") : this.attrs.x;
			this.oy = this.type == "rect" ? this.attr("y") : this.attrs.y;
			this.animate({"fill-opacity": .2}, 500);
		},
		move = function (dx, dy) {
			var att = {x: this.ox + dx, y: this.oy + dy};
			this.attr(att);
			for (var i = connections.length; i--;) {
				thisApplicationsMap.map.connection(connections[i]);
			}
			thisApplicationsMap.map.safari();
		},
		up = function () {
			this.animate({"fill-opacity": 1}, 500);
		},
		initX = 10,
		initY = 10,
		lastX = initX,
		lastY = initY,
		incX = 100,
		incY = 100,
		maxX = 6,
		maxy = 10,
		tip = $("#tip");
		
		thisApplicationsMap.addConnection = function (item1, item2) {
			connections.push(thisApplicationsMap.map.connection(shapes[item1.id], shapes[item2.id]));
		};
		
		thisApplicationsMap.object2Item = function (item) {
			switch(item.getType()) {
				case "Application":
					return applications[item.id];
				case "Database":
					return databases[item.id];
				default:
						return null;
			};
		};

		thisApplicationsMap.nextPosition = function() {
			var p = new Object();
			p.x = lastX;
			p.y = lastY;

			lastX += incX;
			//lastY += incY;

			if(lastX > (incX * maxX) ) {
				lastX = initX;
				lastY += incY;
			}
			
			return p;
		};

		thisApplicationsMap.resetPosition = function () {
			lastX = initX;
			lastY = initY;
		};

		thisApplicationsMap.sortUnorderedList = function(ul, sortDescending) {
		  if(typeof ul == "string")
		    ul = document.getElementById(ul);
		
		  // Idiot-proof, remove if you want
		  if(!ul) {
		    alert("The UL object is null!");
		    return;
		  }
		
		  // Get the list items and setup an array for sorting
		  var lis = ul.getElementsByTagName("LI");
		  var vals = [];
		
		  // Populate the array
		  for(var i = 0, l = lis.length; i < l; i++)
		    vals.push(lis[i].innerHTML);
		
		  // Sort it
		  vals.sort();
		  
		  // Sometimes you gotta DESC
		  if(sortDescending)
		    vals.reverse();
		
		  // Change the list on the page
		  for(var i = 0, l = lis.length; i < l; i++)
		    lis[i].innerHTML = vals[i];
		};

		return thisApplicationsMap;
	}
}());

Array.prototype.clear = function () {
	this.length = 0;
};

String.prototype.hashCode = function(){
	var hash = 0;
	if (this.length == 0) return hash;
	for (i = 0; i < this.length; i++) {
		char = this.charCodeAt(i);
		hash = ((hash<<5)-hash)+char;
		hash = hash & hash; // Convert to 32bit integer
	}
	return hash;
}

String.prototype.br2nl = function() {
    return this.replace(/<br\s*\/?>/mg,"\n");
 };
 
Object.prototype.getType = function() { 
   return this.objectType != undefined ? this.objectType : '';
};
